//+------------------------------------------------------------------+
//|                                               Osyris_Pips_v2.mq4 |
//|                                   Copyright  2008, Paul_Osyris. |
//|                                          paul.yohanson@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Paul_Osyris."
#property link      "paul.yohanson@gmail.com"



extern bool DebugPrints = false;
extern int ShiftInPips = 25;
extern int SlippInPips = 3;

extern double Code = 1000001.0;
extern double Account = 1000001.0;
extern double TakeProfit = 50.0;
extern double TP_1 = 100.0;
extern double Lots = 1;
extern double X_Lots  = 2.0;
extern double StopLoss = 1300.0; // if MaxTrades = 3; ~~ 300.0;
extern double TrailingStop = 0.0;
extern int MaxTrades = 1;
extern int Pips = 70;
extern bool SecureProfitProtection = true;
extern int SecureProfit = 20000;
extern int OrderstoProtect = 3;
extern int AllSymbolsProtect = 0;
extern bool EquityProtection = FALSE;
extern int AccountEquityPercentProtection = 50;
extern bool AccountMoneyProtection = true;
extern double AccountMoneyProtectionValue = 20000.0;
extern bool NewsFileProtection = FALSE;
extern int NewsFileSize = 124;
extern int BrokersTZ = 3;
extern int NewsFileTZ = 0;
extern bool TradeOnFriday = TRUE;
extern int OrdersTimeAlive = 0;
extern bool ReverseCondition = TRUE;
extern bool SetLimitOrders = TRUE;
extern int mm = 0;
extern int risk = 50;
extern int AccountType = 2;
extern int MagicNumber = 123;
extern int MagicNumber_2 = 1234;
extern int Manual = 0;
extern int OpenOrdersBasedOn = 2;
extern bool ExitWithOpenOrdersBasedON = TRUE;
extern int TimeZone = 2;
extern color ArrowsColor = Black;
extern bool RightSideLabel = TRUE;
extern double PercentProfit    = 3.0 ;//  
extern double PercentLoss       =-70.0;//  
extern double PercentTrailing   =15.0;//    ,   0  .
extern double Step              =0.01;//  


bool SigCloseOrders;
double _PercentTrailing,_PercentLoss;

int g_count_236 = 0;
int gi_unused_240 = 0;
int g_count_244 = 0;
int g_count_248 = 0;
extern int g_slippage_252 = 10;
double g_price_256 = 0.0;
double g_price_264 = 0.0;
double g_ask_272 = 0.0;
double g_bid_280 = 0.0;
double gd_288 = 0.0;
double g_lots_296 = 0.0;
   double         MarginPercent;
      static double  LowMarginPercent = 10000000;
int g_cmd_304 = OP_BUY;
int g_price_308 = 0;
int g_price_312 = 0;
bool gi_316 = TRUE;
double g_ord_open_price_320 = 0.0;
int gi_328 = 0;
double gd_332 = 0.0;
int gi_unused_340 = 0;
int gi_344 = 0;
double gd_unused_348 = 0.0;
double gd_unused_356 = 0.0;
double gd_unused_364 = 0.0;
double g_tickvalue_372 = 0.0;
bool gi_unused_380 = FALSE;
double gd_384 = 0.0;
double gd_unused_392 = 0.0;
double gd_unused_400 = 0.0;
int gia_408[][2];
bool gi_412 = FALSE;
string gs_416 = "2030.01.12 23:00";
int g_symbol_424 = NULL;
int g_datetime_428 = 0;




   double WeekHigh;
   double WeekLow;
   double WeekClose;
   double Weekly_Price[][6];
   double WeekPivot,WS1,WS2,WS3,WR1,WR2,WR3;
   
   
   double r3;
   double r2;
   double r1;
   double s1;
   double s2;
   double s3;

int init() {
   int li_0 = ArrayResize(gia_408, NewsFileSize);
   if (li_0 == 0) Print("ERROR RESIZING THE NEWS FILE ARRAY");
   _PercentTrailing=PercentTrailing;
   _PercentLoss=PercentLoss;
   return (0);
}

int deinit() {
   return (0);
}

int start()



/*/---------------------------------------------+
                          Pivots  
 ------------------------------------------------*/ 
 {
 
double rates[1][6],yesterday_close,yesterday_high,yesterday_low;
ArrayCopyRates(rates, Symbol(), PERIOD_D1);

{
if(DayOfWeek() == 1)
{
   if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,1)) == 5)
   {
       yesterday_close = rates[1][4];
       yesterday_high = rates[1][3];
       yesterday_low = rates[1][2];
   }
   else
   {
      for(int d = 5;d>=0;d--)
      {
         if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,d)) == 5)
         {
             yesterday_close = rates[d][4];
             yesterday_high = rates[d][3];
             yesterday_low = rates[d][2];
         }
         
      }  
   }
}
else
{
    yesterday_close = rates[1][4];
    yesterday_high = rates[1][3];
    yesterday_low = rates[1][2];
}


//---- Calculate Pivots


double R = yesterday_high - yesterday_low;//range
double p = (yesterday_high + yesterday_low + yesterday_close)/3;// Standard Pivot
 r3 = p + (R * 1.000);
 r2 = p + (R * 0.618);
 r1 = p + (R * 0.382);
 s1 = p - (R * 0.382);
 s2 = p - (R * 0.618);
 s3 = p - (R * 1.000);
 
 ArrayCopyRates(Weekly_Price, Symbol(), 10080);

WeekHigh  = Weekly_Price[1][3];
WeekLow   = Weekly_Price[1][2];
WeekClose = Weekly_Price[1][4];

WeekPivot = ((WeekHigh + WeekLow + WeekClose)/3);

      WR1 = (2*WeekPivot)-WeekLow;
      WS1 = (2*WeekPivot)-WeekHigh;

      WR2 = WeekPivot+(WR1-WS1);
      WS2 = WeekPivot-(WR1-WS1);

      WS3 = (WeekLow - (2*(WeekHigh-WeekPivot)));
      WR3 = (WeekHigh + (2*(WeekPivot-WeekLow)));

   
  }
  //------------------------------------------------------------------------------------------
  //------------------------------------------------------------------------------------------
  //------------------------------------------------------------------------------------------





 {
//----
  if(IsConnected()==false){ObjectSetText("TimeExpert","     ",8,"Verdana",Yellow);return(0);}
  if(IsExpertEnabled()==false){ObjectSetText("TimeExpert","     ",8,"Verdana",Yellow);return(0);}
  if(IsTradeAllowed()==false){ObjectSetText("TimeExpert"," . .    . . . ",8,"Verdana",Yellow);return(0);}
  if(IsTradeContextBusy()==true){ObjectSetText("TimeExpert","     ",8,"Verdana",Yellow);return(0);}
//----  
  if(TotalOrders()==0)
    {
    SigCloseOrders=false;
    _PercentTrailing=PercentTrailing;
    _PercentLoss=PercentLoss;
    }
//----
  if(PercentTrailing!=0 && SigCloseOrders==false)
    {
    if((EquityAccount()/AccountBalance()-1)*100>=_PercentTrailing+Step)
      {
      _PercentTrailing=_PercentTrailing+Step;
      _PercentLoss=(EquityAccount()/AccountBalance()-1)*100-PercentTrailing;
      }
    }
//----    
  /*int currentOpenOrders = GetOpenOrdersCount();

    if(currentOpenOrders > 2)
 
   {
   PercentProfit = 0.001;
   }
   else 
   {
   PercentProfit = 100;
   
    }
   */

  if(SigCloseOrders==false && 
    ((EquityAccount()/AccountBalance()-1)*100>=PercentProfit ||
     (EquityAccount()/AccountBalance()-1)*100<=_PercentLoss))
    {
    SigCloseOrders=true;
    }
//----
  if(SigCloseOrders==true && TotalOrders()>0)
    {
    CloseOrders();return;
    }
//----
 /*int OrderPrice = GetLastOrderPrice();
  if (OrderPrice == OrderOpenPrice())
  {
  gi_316 = FALSE;
  }
  else
  {
   gi_316 = TRUE;
  }
  */ 
      if(AccountMargin()!=0)
   {
      MarginPercent = MathRound((AccountEquity() / AccountMargin()) * 10);
   }   

   if (LowMarginPercent > MarginPercent) LowMarginPercent = MarginPercent;

       
          
   if (RightSideLabel) 
   {
      string MarPercent = DoubleToStr(MarginPercent, 0);
      string LowMarPercent = DoubleToStr(LowMarginPercent, 0);

      string AcctBalance = DoubleToStr(AccountBalance(), 0);
      ObjectDelete("MarginPercent");

      if (ObjectFind("MarginPercent") != 0)
      {
         ObjectCreate("MarginPercent", OBJ_TEXT, 0, Time[0], Close[0]);
         ObjectSetText("MarginPercent", MarPercent + "%  " + LowMarPercent + "%  $" + AcctBalance, 10, "Arial Black", DodgerBlue);
      }
      else
      {
         ObjectMove("MarginPercent", 0, Time[0], Close[0]);
      }
   }

 
//----
  
  



   bool l_bool_4;
   int l_pos_0 = 0;
   string ls_8 = "";
   string ls_unused_16 = "This version has expired.";
   if (AccountType == 0) {
      if (mm != 0) gd_288 = MathCeil(AccountBalance() * risk / 10000.0);
      else gd_288 = Lots;
   }
   if (AccountType == 1) {
      if (mm != 0) gd_288 = MathCeil(AccountBalance() * risk / 10000.0) / 10.0;
      else gd_288 = Lots;
   }
   if (AccountType == 2) {
      if (mm != 0) gd_288 = MathCeil(AccountBalance() * risk / 10000.0) / 100.0;
      else gd_288 = Lots;
   }
   if (gd_288 < 0.01) gd_288 = 0.01;
   if (gd_288 > 100.0) gd_288 = 100;
   g_count_236 = 0;
   g_count_244 = 0;
   g_count_248 = 0;
   for (l_pos_0 = 0; l_pos_0 < OrdersTotal(); l_pos_0++) {
      if (OrderSelect(l_pos_0, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber || OrderMagicNumber()==MagicNumber_2) {
            if (OrderType() == OP_BUY || OrderType() == OP_SELL) {
               g_count_244++;
               g_datetime_428 = OrderOpenTime();
            }
            if (OrderType() == OP_SELLLIMIT || OrderType() == OP_BUYLIMIT) g_count_248++;
            g_count_236++;
         }
      }
   }
   if (NewsFileProtection && Volume[0] < 2.0) {
      if (!gi_412 || (TimeHour(TimeZoneConvert(TimeCurrent(), BrokersTZ, NewsFileTZ)) == 0 && TimeMinute(TimeZoneConvert(TimeCurrent(), BrokersTZ, NewsFileTZ)) <= 3)) OrdersControlbyTime();
      g_symbol_424 = CurTimeInNonTrading();
   }
   if (g_count_236 < 1) {
      if (NewsFileProtection && g_symbol_424 == 1) return (0);
      if (!TradeOnFriday && DayOfWeek() == 5) {
         Comment("TradeOnfriday is False");
         return (0);
      }
   }
   g_tickvalue_372 = MarketInfo(Symbol(), MODE_TICKVALUE);
   if (g_tickvalue_372 == 0.0) g_tickvalue_372 = 5;
   if (AccountMoneyProtection && AccountBalance() - AccountEquity() >= AccountMoneyProtectionValue) {
      ls_8 = ls_8 
      + "\nClosing orders because account money protection was triggered.";
      Print("Closing orders because account money protection was triggered. Balance: ", AccountBalance(), " Equity: ", AccountEquity());
      gi_328 = g_count_236 + 1;
      gi_316 = FALSE;
      return (0);
   }
   if (EquityProtection && AccountEquity() <= AccountBalance() * AccountEquityPercentProtection / 100.0) {
      ls_8 = ls_8 
      + "\nClosing orders because account equity protection was triggered.";
      Print("Closing orders because account equity protection was triggered. Balance: ", AccountBalance(), " Equity: ", AccountEquity());
      gi_328 = g_count_236 + 1;
      gi_316 = FALSE;
      return (0);
   }
   if (NewsFileProtection && g_symbol_424 == 1) {
      gi_328 = g_count_236 + 1;
      gi_316 = FALSE;
      ls_8 = ls_8 
      + "\nClosing all orders and stop trading because NewsFileProtection was triggered.";
      Print("Closing all orders and stop trading because NewsFileProtection was triggered.");
   }
   if (!TradeOnFriday && DayOfWeek() == 5) {
      gi_328 = g_count_236 + 1;
      gi_316 = FALSE;
      ls_8 = ls_8 
      + "\nClosing all orders and stop trading because TradeOnFriday protection.";
      Print("Closing all orders and stop trading because TradeOnFriday protection.");
   }
   if (OrdersTimeAlive > 0 && TimeCurrent() - g_datetime_428 > OrdersTimeAlive) {
      gi_328 = g_count_236 + 1;
      gi_316 = FALSE;
      ls_8 = ls_8 
      + "\nClosing all orders because OrdersTimeAlive protection.";
      Print("Closing all orders because OrdersTimeAlive protection.");
      
   }
   if (gi_328 > g_count_236) {
      for (l_pos_0 = OrdersTotal() - 1; l_pos_0 >= 0; l_pos_0--) {
         if (OrderSelect(l_pos_0, SELECT_BY_POS, MODE_TRADES)) {
            g_cmd_304 = OrderType();
            if ((OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber || OrderMagicNumber()==MagicNumber_2) || AllSymbolsProtect == 1) {
               if (g_cmd_304 == OP_BUY) OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), g_slippage_252, ArrowsColor);
               if (g_cmd_304 == OP_SELL) OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), g_slippage_252, ArrowsColor);
               if (g_cmd_304 == OP_SELLLIMIT || g_cmd_304 == OP_BUYLIMIT || g_cmd_304 == OP_BUYSTOP || g_cmd_304 == OP_SELLSTOP) OrderDelete(OrderTicket());
               GetOpenOrdersCount();
               return (0);
            }
         }
      }
   }
   gi_328 = g_count_236;
   if (g_count_236 >= MaxTrades) gi_316 = FALSE;
   else gi_316 = TRUE;
   if (g_ord_open_price_320 == 0.0) {
      for (l_pos_0 = 0; l_pos_0 < OrdersTotal(); l_pos_0++) {
         if (OrderSelect(l_pos_0, SELECT_BY_POS, MODE_TRADES)) {
            g_cmd_304 = OrderType();
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber || OrderMagicNumber()==MagicNumber_2) {
               g_ord_open_price_320 = OrderOpenPrice();
               if (g_cmd_304 == OP_BUY) g_price_308 = 2;
               if (g_cmd_304 == OP_SELL) g_price_308 = 1;
            }
         }
      }
   }
   if (SecureProfitProtection && g_count_244 >= MaxTrades - OrderstoProtect) {
      gd_332 = 0;
      gi_unused_340 = 0;
      gi_344 = FALSE;
      gd_unused_348 = 0;
      gd_unused_356 = 0;
      for (l_pos_0 = 0; l_pos_0 < OrdersTotal(); l_pos_0++) {
         if (OrderSelect(l_pos_0, SELECT_BY_POS, MODE_TRADES) == FALSE) break;
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderMagicNumber()==MagicNumber_2) {
            if (OrderType() == OP_BUY || OrderType() == OP_SELL) {
               gi_unused_340 = OrderTicket();
               if (OrderType() == OP_BUY) gi_344 = FALSE;
               if (OrderType() == OP_SELL) gi_344 = TRUE;
               gd_unused_348 = OrderClosePrice();
               gd_unused_356 = OrderLots();
               if (gi_344 == FALSE) {
                  if (OrderClosePrice() < OrderOpenPrice()) gd_332 -= (OrderOpenPrice() - OrderClosePrice()) * OrderLots() / Point;
                  if (OrderClosePrice() > OrderOpenPrice()) gd_332 += (OrderClosePrice() - OrderOpenPrice()) * OrderLots() / Point;
               }
               if (gi_344 == TRUE) {
                  if (OrderClosePrice() > OrderOpenPrice()) gd_332 -= (OrderClosePrice() - OrderOpenPrice()) * OrderLots() / Point;
                  if (OrderClosePrice() < OrderOpenPrice()) gd_332 += (OrderOpenPrice() - OrderClosePrice()) * OrderLots() / Point;
               }
            }
         }
      }
      gd_332 *= g_tickvalue_372;
      if (AllSymbolsProtect == 1) gd_384 = AccountBalance();
      else gd_384 = SecureProfit;
      if (gd_332 >= gd_384) {
         ls_8 = ls_8 
         + "\nClosing orders because account protection with SecureProfit was triggered.";
         Print("Closing orders because account protection with SecureProfit was triggered. Balance: ", AccountBalance(), " Equity: ", AccountEquity(), " Profit: ", gd_332);
         gi_328 = g_count_236 + 1;
         gi_316 = FALSE;
         return (0);
      }
   }
   g_price_312 = 3;
   switch (OpenOrdersBasedOn) {
   case 0:
      g_price_312 = OpenOrdersBasedOnMACD();
      break;
   case 1:
      g_price_312 = OpenOrdersBasedOnPivot();
      break;
   case 2:
      g_price_312 = OpenOrdersBasedOnSupRes();
      break;
   case 3:
      g_price_312 = OpenOrdersBasedOnPSAR();
      break;
   case 4:
      g_price_312 = OpenOrdersBasedOnBrainTrend1Sig();
      break;
   case 5:
      g_price_312 = OpenOrdersBasedOnSell();
      break;
   case 6:
      g_price_312 = OpenOrdersBasedOnBuy();
      break;
   case 7:
      g_price_312 = OpenOrdersBasedOnRSI2MA();
      break;
   case 8:
      g_price_312 = OpenOrdersBasedOnMovingAverage();
      break;
   case 9:
      g_price_312 = OpenOrdersBasedOnCCI();
      break;
   case 10:
      g_price_312 = OpenOrdersBasedOnBullsandBears();
      break;
   case 11:
      g_price_312 = OpenOrdersBasedOnTrendManager();
      break;
   case 12:
      g_price_312 = OpenOrdersBasedOnFXFish();
      break;
   case 13:
      g_price_312 = OpenOrdersBasedOnOpenClose();
      break;
   case 14:
      g_price_312 = OpenOrdersBasedOnOnSupResFXFish();
      break; 
   case 15:
      g_price_312 = OpenOrdersBasedOnFXFish4();
      break;     
   default:
      g_price_312 = OpenOrdersBasedOnMACD();
   }
     if (g_count_236 < 1 && Manual == 0) {
      g_price_308 = g_price_312;
      if (ReverseCondition) {
         if (g_price_308 == 1) g_price_308 = 2;
         else
            if (g_price_308 == 2) g_price_308 = 1;
      }
   }
   if (ExitWithOpenOrdersBasedON && ReverseCondition) {
      if (g_price_312 == 1) g_price_312 = 2;
      else
         if (g_price_312 == 2) g_price_312 = 1;
   }
   for (l_pos_0 = OrdersTotal() - 1; l_pos_0 >= 0; l_pos_0--) {
      if (OrderSelect(l_pos_0, SELECT_BY_POS, MODE_TRADES) == FALSE) break;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
         if (OrderType() == OP_SELL) {
            if (ExitWithOpenOrdersBasedON && g_price_312 == 2) {
               gi_328 = g_count_236 + 1;
               gi_316 = FALSE;
               ls_8 = ls_8 
               + "\nClosing all orders because Indicator triggered another signal.";
               Print("Closing all orders because Indicator triggered another signal.");
            }
            if (TrailingStop > 0.0) 
            {
            if (OrderMagicNumber()==MagicNumber_2)
            {
               if (OrderOpenPrice() - OrderClosePrice() >= TrailingStop * Point + Pips * Point) 
               {
                  if (OrderStopLoss() > OrderClosePrice() + TrailingStop * Point) 
                  {
                     l_bool_4 = OrderModify(OrderTicket(), OrderOpenPrice(), OrderClosePrice() + TrailingStop * Point, OrderOpenPrice() - TP_1 * Point, 0, Purple);
                     if (l_bool_4 != TRUE) Print("LastError = ", GetLastError());
                     else OrderPrint();
                     return (0);
                  }
               }
            }
         }
       } 
         if (OrderType() == OP_BUY) {
            if (ExitWithOpenOrdersBasedON && g_price_312 == 1) {
               gi_328 = g_count_236 + 1;
               gi_316 = FALSE;
               ls_8 = ls_8 
               + "\nClosing all orders because Indicator triggered another signal.";
               Print("Closing all orders because Indicator triggered another signal.");
            }
            if (TrailingStop > 0.0)
            {
             if (OrderMagicNumber()==MagicNumber_2)
            {
               if (OrderClosePrice() - OrderOpenPrice() >= TrailingStop  * Point) 
               {
                  if (OrderStopLoss() < OrderClosePrice() - TrailingStop * Point) 
                  {
                     l_bool_4 = OrderModify(OrderTicket(), OrderOpenPrice(), OrderClosePrice() - TrailingStop * Point, OrderOpenPrice() + TP_1 * Point + TrailingStop * Point, 0, ArrowsColor);
                     if (l_bool_4 != TRUE) Print("LastError = ", GetLastError());
                     else OrderPrint();
                     return (0);
                  }
               }
            }
         }
      }
    }
  }
   if (!IsTesting()) {
      if (g_price_308 == 3 && g_count_236 < 1) {
         ls_8 = ls_8 
         + "\nNo conditions to open trades";
      }
      Comment("LastPrice=", g_ord_open_price_320, " Previous open orders=", gi_328, 
         "\nContinue opening=", gi_316, " OrderType=", g_price_308, 
      "\nLots=", gd_288, ls_8,
        "\n ",DoubleToStr((EquityAccount()/AccountBalance()-1)*100,2),
          "% \n ",PercentProfit,"%  ",_PercentLoss,"%" );
   
   }
   if (g_count_236 < 1) OpenMarketOrders();
   else {
      if (SetLimitOrders) OpenLimitOrders();
      else OpenMarketOrders();
   }
   return (0);
}
}

void OpenMarketOrders() {
   int l_count_0 = 0;
   if (g_price_308 == 1 && gi_316) {
      if (Bid - g_ord_open_price_320 >= Pips * Point || g_count_236 < 1) {
         g_bid_280 = Bid;
         g_ord_open_price_320 = 0;
         if (TakeProfit == 0.0) g_price_264 = 0;
         else g_price_264 = g_bid_280 - TakeProfit * Point;
         if (StopLoss == 0.0) g_price_256 = 0;
         else g_price_256 = g_bid_280 + StopLoss * Point;
         if (g_count_236 != 0) {
            g_lots_296 = gd_288;
            for (l_count_0 = 0; l_count_0 < g_count_236; l_count_0++) {
               if (MaxTrades > 12) g_lots_296 = NormalizeDouble(1.5 * g_lots_296, 2);
               else g_lots_296 = NormalizeDouble( g_lots_296 / X_Lots , 2);
            }
         } else g_lots_296 = gd_288;
         if (g_lots_296 > 100.0) g_lots_296 = 100;
         OrderSend(Symbol(), OP_SELL, g_lots_296, g_bid_280, g_slippage_252, g_price_256, Bid-TP_1*Point, "Osyris_Pips" + MagicNumber, MagicNumber, 0, ArrowsColor);
         return;
      }
   }
   if (g_price_308 == 2 && gi_316) {
      if (g_ord_open_price_320 - Ask >= Pips * Point || g_count_236 < 1) {
         g_ask_272 = Ask;
         g_ord_open_price_320 = 0;
         if (TakeProfit == 0.0) g_price_264 = 0;
         else g_price_264 = g_ask_272 + TakeProfit * Point;
         if (StopLoss == 0.0) g_price_256 = 0;
         else g_price_256 = g_ask_272 - StopLoss * Point;
         if (g_count_236 != 0) {
            g_lots_296 = gd_288;
            for (l_count_0 = 0; l_count_0 < g_count_236; l_count_0++) {
               if (MaxTrades > 12) g_lots_296 = NormalizeDouble(1.5 * g_lots_296, 2);
               else g_lots_296 = NormalizeDouble(g_lots_296 / X_Lots, 2);
            }
         } else g_lots_296 = gd_288;
         if (g_lots_296 > 100.0) g_lots_296 = 100;
         OrderSend(Symbol(), OP_BUY, g_lots_296, g_ask_272, g_slippage_252, g_price_256, Ask+TP_1*Point, "Osyris_Pips" + MagicNumber, MagicNumber, 0, ArrowsColor);
         return;
      }
   }
}

void OpenLimitOrders() {
   int l_count_0 = 0;
   if (g_price_308 == 1 && gi_316) {
      g_bid_280 = g_ord_open_price_320 + Pips * Point;
      g_ord_open_price_320 = 0;
      if (TakeProfit == 0.0) g_price_264 = 0;
      else g_price_264 = g_bid_280 - TakeProfit * Point;
      if (StopLoss == 0.0) g_price_256 = 0;
      else g_price_256 = g_bid_280 + StopLoss * Point;
      if (g_count_236 != 0) {
         g_lots_296 = gd_288;
         for (l_count_0 = 0; l_count_0 < g_count_236; l_count_0++) {
            if (MaxTrades > 12) g_lots_296 = NormalizeDouble(1.5 * g_lots_296, 2);
            else g_lots_296 = NormalizeDouble(X_Lots * g_lots_296, 2);
         }
      } else g_lots_296 = gd_288;
      if (g_lots_296 > 100.0) g_lots_296 = 100;
      OrderSend(Symbol(), OP_SELLLIMIT, g_lots_296, g_bid_280, g_slippage_252, g_price_256, g_price_264, "Osyris_Pips" + MagicNumber, MagicNumber_2,0.02, ArrowsColor);
      return;
   }
   if (g_price_308 == 2 && gi_316) {
      g_ask_272 = g_ord_open_price_320 - Pips * Point;
      g_ord_open_price_320 = 0;
      if (TakeProfit == 0.0) g_price_264 = 0;
      else g_price_264 = g_ask_272 + TakeProfit * Point;
      if (StopLoss == 0.0) g_price_256 = 0;
      else g_price_256 = g_ask_272 - StopLoss * Point;
      if (g_count_236 != 0) {
         g_lots_296 = gd_288;
         for (l_count_0 = 0; l_count_0 < g_count_236; l_count_0++) {
            if (MaxTrades > 12) g_lots_296 = NormalizeDouble(1.5 * g_lots_296, 2);
            else g_lots_296 = NormalizeDouble(X_Lots * g_lots_296, 2);
         }
      } else g_lots_296 = gd_288;
      if (g_lots_296 > 100.0) g_lots_296 = 100;
      OrderSend(Symbol(), OP_BUYLIMIT, g_lots_296, g_ask_272, g_slippage_252, g_price_256, g_price_264, "Osyris_Pips" + MagicNumber, MagicNumber_2, 0.02, ArrowsColor);
      return;
   }
}

int OrdersControlbyTime() {
   int l_file_0 = FileOpen("Dailyfx_Global_Economic_CalendarCAX7HXLV.csv", FILE_CSV|FILE_READ, ';');
   if (l_file_0 < 1) {
      Print("Dailyfx_Global_Economic_CalendarCAX7HXLV.csv not found, the last error is ", GetLastError());
      gi_412 = FALSE;
      return (0);
   }
   int l_index_4 = 0;
   int li_unused_8 = 0;
   while (!FileIsEnding(l_file_0) || l_index_4 < NewsFileSize) {
      if (!FileIsEnding(l_file_0)) {
         gia_408[l_index_4][0] = StrToTime(FileReadString(l_file_0, 0));
         gia_408[l_index_4][1] = StrToTime(FileReadString(l_file_0, 1));
      } else {
         gia_408[l_index_4][0] = StrToTime(gs_416);
         gia_408[l_index_4][1] = StrToTime(gs_416);
      }
      l_index_4++;
   }
   gi_412 = TRUE;
   FileClose(l_file_0);
   return (1);
}

int CurTimeInNonTrading() {
   int li_ret_4 = 0;
   for (int l_index_0 = 0; l_index_0 < NewsFileSize; l_index_0++) {
      if (gia_408[l_index_0][0] == StrToTime(gs_416)) break;
      if (TimeZoneConvert(TimeCurrent(), BrokersTZ, NewsFileTZ) >= gia_408[l_index_0][0] && TimeZoneConvert(TimeCurrent(), BrokersTZ, NewsFileTZ) < gia_408[l_index_0][1]) li_ret_4 = 1;
      if (TimeZoneConvert(TimeCurrent(), BrokersTZ, NewsFileTZ) >= gia_408[l_index_0][1]) li_ret_4 = 2;
   }
   return (li_ret_4);
}
//+------------------------------------------------------------------+
int TotalOrders()
  {
  int order;
   for(int pos=OrdersTotal()-1;pos>=0;pos--)
    {
    if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES)==true)
      {
      if(OrderType()<=OP_SELL && OrderMagicNumber()==MagicNumber && OrderMagicNumber()==MagicNumber_2)
        {
        order++;             
        }
      }
    else Print("         (",GetLastError(),")");
    }
  return(order);
  }
//+------------------------------------------------------------------+
void CloseOrders()
  {
  for(int pos=OrdersTotal()-1;pos>=0;pos--)
    {
    if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES)==true)
      {
      if(OrderType()<=OP_SELL && OrderMagicNumber()==MagicNumber || OrderMagicNumber()==MagicNumber_2)
        {
        OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),5,CLR_NONE);             
        }
      }
    else Print("         (",GetLastError(),")");
    }
  }
//+------------------------------------------------------------------+
double EquityAccount()
  {
  double Profit;
   for(int pos=OrdersTotal()-1;pos>=0;pos--)
    {
    if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES)==true)
      {
      if(OrderType()<=OP_SELL && OrderMagicNumber()==MagicNumber && OrderMagicNumber()==MagicNumber_2)
        {
        Profit+=OrderSwap()+OrderProfit();             
        }
      }
    else Print("         (",GetLastError(),")");
    }
  return(Profit+AccountBalance());
  }
  
/*double  GetLastOrderPrice()
{
   int ticket = -1;
   datetime dt = 0;
   double OpenPrice=-1;
  
   int cnt = HistoryTotal();
   for (int i; i < cnt; i++) 
   {
      if (!OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) 
         continue;
      //  
      //Print("i=", i, "OrderMagicNumber()=", OrderMagicNumber(), "OrderTicket()=", OrderTicket());
    
      //if (OrderSymbol() != Symbol()) continue;
      
      if ((MagicNumber! && OrderMagicNumber()!=MagicNumber) || (OrderType() != OP_BUY && OrderType() != OP_SELL) ) 
         continue;
    
      if (OrderCloseTime() > dt) 
      {
         dt = OrderCloseTime();
         ticket = OrderTicket();
         
         OpenPrice = OrderOpenPrice();
      }
   }
   return(OpenPrice);    
}
    
*/    
  int GetOpenOrdersCount()
{
   int total = OrdersTotal();
   int sum = 0;
   for (int pos = 0; pos < total; pos++)
   {
      if (OrderSelect(pos, SELECT_BY_POS, MODE_TRADES))
      {
         if ( OrderType() == OP_BUY || OrderType() == OP_SELL && OrderMagicNumber()==MagicNumber && OrderMagicNumber()==MagicNumber_2)
         {
            sum++;
         }
      }
      else
      {
         //Print("[AB]Can't select order!");
         Print("       (",GetLastError(),")");
         return (-1);
      }
   }
   return (sum);
}


int TimeZoneConvert(int ai_0, int ai_4, int ai_8) {
   int li_12 = ai_4 - ai_8;
   int li_16 = TimeHour(ai_0) - li_12;
   int li_ret_20 = ai_0;
   if (ai_4 < -12 || ai_4 > 14) {
      Print("Zone1 value is invalid (", ai_4, ") the value must be from -12 to +14");
      return (ai_0);
   }
   if (ai_8 < -12 || ai_8 > 14) {
      Print("Zone2 value is invalid (", ai_8, ") the value must be from -12 to +14");
      return (ai_0);
   }
   li_ret_20 = StrToTime(TimeYear(ai_0) + "." + TimeMonth(ai_0) + "." + TimeDay(ai_0) + " " + li_16 + ":" + TimeMinute(ai_0));
   if (li_16 < 0) {
      li_16 += 24;
      li_ret_20 = StrToTime(TimeYear(ai_0) + "." + TimeMonth(ai_0) + "." + TimeDay(ai_0) + " " + li_16 + ":" + TimeMinute(ai_0)) - 86400;
   }
   if (li_16 > 24) {
      li_16 -= 24;
      li_ret_20 = StrToTime(TimeYear(ai_0) + "." + TimeMonth(ai_0) + "." + TimeDay(ai_0) + " " + li_16 + ":" + TimeMinute(ai_0)) + 86400;
   }
   return (li_ret_20);
}

int OpenOrdersBasedOnMACD() {
   int li_ret_0 = 3;
   double l_imacd_4 = iMACD(NULL, 0, 12, 26, 9, PRICE_CLOSE, MODE_MAIN, 0);
   double l_imacd_12 = iMACD(NULL, 0, 12, 26, 9, PRICE_CLOSE, MODE_MAIN, 1);
   double l_imacd_20 = iMACD(NULL, 0, 12, 26, 9, PRICE_CLOSE, MODE_SIGNAL, 0);
   double l_imacd_28 = iMACD(NULL, 0, 12, 26, 9, PRICE_CLOSE, MODE_SIGNAL, 1);
   double l_ima_36 = iMA(NULL, 0, 26, 0, MODE_EMA, PRICE_CLOSE, 0);
   double l_ima_44 = iMA(NULL, 0, 26, 0, MODE_EMA, PRICE_CLOSE, 1);
   if (l_imacd_4 < 0.0 && l_imacd_4 > l_imacd_20 && l_imacd_12 < l_imacd_28 && MathAbs(l_imacd_4) > 3.0 * Point && l_ima_36 > l_ima_44) li_ret_0 = 2;
   if (l_imacd_4 > 0.0 && l_imacd_4 < l_imacd_20 && l_imacd_12 > l_imacd_28 && l_imacd_4 > 3.0 * Point && l_ima_36 < l_ima_44) li_ret_0 = 1;
   return (li_ret_0);
}

int OpenOrdersBasedOnPivot() {
   int li_ret_0 = 3;
   double l_icustom_4 = 0;
   l_icustom_4 = iCustom(Symbol(), 0, "Pivot Lines TimeZone", TimeZone, 1, 0, 0, 0, 0);
   if (Close[0] > l_icustom_4) li_ret_0 = 1;
   if (Close[0] < l_icustom_4) li_ret_0 = 2;
   return (li_ret_0);
}
/*
int OpenOrdersBasedOnSupRes() {
   int li_ret_0 = 3;
   double l_icustom_4 = 0;
   double l_icustom_12 = 0;
   l_icustom_4 = iCustom(Symbol(), 0, "Support and Resistance", 0, 0);
   l_icustom_12 = iCustom(Symbol(), 0, "Support and Resistance", 1, 0);
   if (Close[0] <= l_icustom_12 + 4.0 * Point && Close[0] >= l_icustom_12) li_ret_0 = 2;
   if (Close[0] >= l_icustom_4 - 4.0 * Point && Close[0] <= l_icustom_4) li_ret_0 = 1;
   return (li_ret_0);
}
*/
int OpenOrdersBasedOnPSAR() {
   int li_ret_0 = 3;
   if (iSAR(NULL, 0, 0.02, 0.2, 1) <= Low[1] && iSAR(NULL, 0, 0.02, 0.2, 0) > High[0]) li_ret_0 = 1;
   if (iSAR(NULL, 0, 0.02, 0.2, 1) >= High[1] && iSAR(NULL, 0, 0.02, 0.2, 0) < Low[0]) li_ret_0 = 2;
   return (li_ret_0);
}

int OpenOrdersBasedOnBrainTrend1Sig() {
   int li_ret_0 = 3;
   double l_icustom_4 = iCustom(NULL, 0, "BrainTrend1Stop", 10, 0, 0);
   double l_icustom_12 = iCustom(NULL, 0, "BrainTrend1Stop", 10, 0, 1);
   double l_icustom_20 = iCustom(NULL, 0, "BrainTrend1Stop", 10, 1, 0);
   double l_icustom_28 = iCustom(NULL, 0, "BrainTrend1Stop", 10, 1, 1);
   if (l_icustom_4 && !l_icustom_12) li_ret_0 = 1;
   if (l_icustom_20 && !l_icustom_28) li_ret_0 = 2;
   return (li_ret_0);
}

int OpenOrdersBasedOnSell() {
   return (1);
}

int OpenOrdersBasedOnBuy() {
   return (2);
}

int OpenOrdersBasedOnRSI2MA() {
   int li_ret_0 = 3;
   double l_icustom_4 = iCustom(Symbol(), 0, "RSI 2MA", 14, 21, 9, 70, 30, "SMA", "--", 0, 3, 1, 1);
   double l_icustom_12 = iCustom(Symbol(), 0, "RSI 2MA", 14, 21, 9, 70, 30, "SMA", "--", 0, 3, 2, 1);
   double l_icustom_20 = iCustom(Symbol(), 0, "RSI 2MA", 14, 21, 9, 70, 30, "SMA", "--", 0, 3, 1, 2);
   double l_icustom_28 = iCustom(Symbol(), 0, "RSI 2MA", 14, 21, 9, 70, 30, "SMA", "--", 0, 3, 2, 2);
   if (l_icustom_20 >= l_icustom_28 && l_icustom_4 < l_icustom_12) li_ret_0 = 1;
   if (l_icustom_20 <= l_icustom_28 && l_icustom_4 > l_icustom_12) li_ret_0 = 2;
   return (li_ret_0);
}

int OpenOrdersBasedOnMovingAverage() {
   int li_ret_0 = 3;
   double l_ima_4 = iMA(NULL, 0, 12, 6, MODE_SMA, PRICE_CLOSE, 0);
   if (Open[1] > l_ima_4 && Close[1] < l_ima_4) li_ret_0 = 1;
   if (Open[1] < l_ima_4 && Close[1] > l_ima_4) li_ret_0 = 2;
   return (li_ret_0);
}

int OpenOrdersBasedOnCCI() {
   int li_ret_0 = 3;
   double l_icci_4 = iCCI(Symbol(), 0, 8, PRICE_LOW, 1);
   double l_icci_12 = iCCI(Symbol(), 0, 8, PRICE_LOW, 2);
   if (l_icci_12 >= 0.0 && l_icci_4 < 0.0) li_ret_0 = 1;
   if (l_icci_12 <= 0.0 && l_icci_4 > 0.0) li_ret_0 = 2;
   return (li_ret_0);
}

int OpenOrdersBasedOnBullsandBears() {
   int li_ret_0 = 3;
   double l_ibullspower_4 = iBullsPower(NULL, 0, 5, PRICE_CLOSE, 1);
   double l_ibearspower_12 = iBearsPower(NULL, 0, 5, PRICE_CLOSE, 1);
   if (l_ibullspower_4 + l_ibearspower_12 < 0.0) li_ret_0 = 1;
   if (l_ibullspower_4 + l_ibearspower_12 > 0.0) li_ret_0 = 2;
   return (li_ret_0);
}

int OpenOrdersBasedOnTrendManager() {
   int li_ret_0 = 3;
   double l_icustom_4 = iCustom(Symbol(), 0, "Trend Manager", 0.0007, 23, 1, 84, 1, 500, 0, 1);
   double l_icustom_12 = iCustom(Symbol(), 0, "Trend Manager", 0.0007, 23, 1, 84, 1, 500, 1, 1);
   if (l_icustom_12 < l_icustom_4) li_ret_0 = 1;
   if (l_icustom_12 > l_icustom_4) li_ret_0 = 2;
   return (li_ret_0);
}

int OpenOrdersBasedOnFXFish() {
   int li_ret_0 = 3;
   double l_icustom_4 = iCustom(Symbol(), 0, "FX_FISH", 10, 0, 1, 0, 0, 1);
   double l_icustom_12 = iCustom(Symbol(), 0, "FX_FISH", 10, 0, 1, 0, 1, 1);
   if (l_icustom_12 < l_icustom_4) li_ret_0 = 1;
   if (l_icustom_12 > l_icustom_4) li_ret_0 = 2;
   return (li_ret_0);
}

int OpenOrdersBasedOnOpenClose() {
   int li_ret_0 = 3;
   if (iOpen(Symbol(), 0, 1) - iClose(Symbol(), 0, 1) > 10.0 * Point) li_ret_0 = 1;
   if (iClose(Symbol(), 0, 1) - iOpen(Symbol(), 0, 1) > 10.0 * Point) li_ret_0 = 2;
   return (li_ret_0);
}

int OpenOrdersBasedOnOnSupResFXFish () {
   int li_ret_0 = 3;
   double l_icustom_4 = iCustom(Symbol(), PERIOD_M5, "FX_FISH", 10, 0, 1, 0, 1, 1);
   double l_icustom_12 = iCustom(Symbol(), PERIOD_M5, "FX_FISH", 10, 0, 1, 0, 0, 1);
   double l_icustom_5 = 0;
   double l_icustom_14 = 0;
   l_icustom_5 = iCustom(Symbol(), 0, "Support and Resistance", 0, 0);
   l_icustom_14 = iCustom(Symbol(), 0, "Support and Resistance", 1, 0);
   if (Close[0] <= l_icustom_14 + 4.0 * Point && Close[0] >= l_icustom_14 && l_icustom_12 > l_icustom_4)li_ret_0 = 2;
   if (Close[0] >= l_icustom_5 - 4.0 * Point && Close[0] <= l_icustom_5 && l_icustom_12 < l_icustom_4)li_ret_0 = 1;

   return (li_ret_0);

}

int OpenOrdersBasedOnFXFish4(){

   int li_ret_0 = 3;
   double l_icustom_1 = iCustom(Symbol(), PERIOD_H4, "FX_FISH", 10, 0, 1, 0, 0, 1);
   double l_icustom_11 = iCustom(Symbol(), PERIOD_H4, "FX_FISH", 10, 0, 1, 0, 1, 1);
   double l_icustom_2 = iCustom(Symbol(), PERIOD_M5, "FX_FISH", 10, 0, 1, 0, 0, 1);
   double l_icustom_12 = iCustom(Symbol(), PERIOD_M5, "FX_FISH", 10, 0, 1, 0, 1, 1);
   double l_icustom_3 = iCustom(Symbol(), PERIOD_M30, "FX_FISH", 10, 0, 1, 0, 0, 1);
   double l_icustom_13 = iCustom(Symbol(), PERIOD_M30, "FX_FISH", 10, 0, 1, 0, 1, 1);
   double l_icustom_4 = iCustom(Symbol(), PERIOD_H1, "FX_FISH", 10, 0, 1, 0, 0, 1);
   double l_icustom_14 = iCustom(Symbol(), PERIOD_H1, "FX_FISH", 10, 0, 1, 0, 1, 1);
   if (l_icustom_11 < l_icustom_1 && l_icustom_12 < l_icustom_2 && l_icustom_13 < l_icustom_3 && l_icustom_14 < l_icustom_4) li_ret_0 = 1;
   if (l_icustom_11 > l_icustom_1 && l_icustom_12 > l_icustom_2 && l_icustom_13 > l_icustom_3 && l_icustom_14 > l_icustom_4) li_ret_0 = 2;
   return (li_ret_0);
}

int OpenOrdersBasedOnSupRes() 
{
   int SignalVal = 3;
   double Resistance_Lvl = 0;
   double Support_Lvl = 0;
   
   Resistance_Lvl = iCustom(Symbol(), 0, "Support and Resistance", 0, 0);
   Support_Lvl = iCustom(Symbol(), 0, "Support and Resistance", 1, 0);
   
   double CurrPrice = Close[0];
   
  if (CurrPrice >= Resistance_Lvl-SlippInPips*Point + ShiftInPips*Point && CurrPrice <= Resistance_Lvl + ShiftInPips*Point) 
      SignalVal = 1;
      
   if(DebugPrints)
      Print("Corrected  Res_Lvl-SlippInPips=[", Resistance_Lvl-SlippInPips*Point + ShiftInPips*Point, "] CurrPrice=[", CurrPrice, "] Corrected Res_Lvl=[", Resistance_Lvl + ShiftInPips*Point, "]");
   
   if (CurrPrice >= Support_Lvl - ShiftInPips*Point && CurrPrice <= Support_Lvl+SlippInPips*Point - ShiftInPips*Point) 
      SignalVal = 2;
      
   if(DebugPrints)
   {
      Print("Corrected  Supp_Lvl=[", Support_Lvl - ShiftInPips*Point, "] CurrPrice=[", CurrPrice, "] Corrected Supp_Lvl+SlippInPips=[", Support_Lvl+SlippInPips*Point - ShiftInPips*Point, "]");
      Print("SignalVal=[",SignalVal,"]");
   }
   
   return (SignalVal);
}

